import {
  select,
  csv,
  scaleLinear,
  scaleTime,
  extent,
  axisLeft,
  axisBottom,
  line,
  curveBasis,
  max,
  timeParse
} from 'd3';

const svg = select('svg');

const width = +svg.attr('width');
const height = +svg.attr('height');

const render = data => {
  const getNumber = d => d.Number;
  const getMonth = d => d.Month;
  
  const xScale = scaleTime()
    .domain(extent(data, getMonth))
    .range([0, width])
    .nice();
  const yScale = scaleLinear()
    .domain([0, max(data, getNumber)])
    .range([height, 0])
    .nice()
  
  const g = svg.append('g');
  
  const lines = line()
    .x(d => xScale(getMonth(d)))
    .y(d => yScale(getNumber(d)))
    .curve(curveBasis);
  
  g.append('path')
      .attr('class', 'line-path')
      .attr('d', lines(data));
  
  //g.selectAll('circle')
  //  .data(data)
  //  .enter()
  //  .append('circle')
  //  .attr('cx', d => xScale(getMonth(d)))
  //  .attr('cy', d => yScale(getNumber(d)))
  //  .attr('r', 20);
  
};

csv('https://vizhub.com/hi-bart/datasets/_penguin.csv')
  .then(data => {
    data.forEach(d => {
      d.Number = +d.Number;
      const parseTime = d3.timeParse("%YM%m");
      d.Month = parseTime(d.Month);
    });
    render(data);
  });